#pragma once

#include <f8/timer.h>

class DownStream;
class DownStreamMgr : public a8::Singleton<DownStreamMgr>
{
 private:
    DownStreamMgr() {};
    friend class a8::Singleton<DownStreamMgr>;

 public:

    void Init();
    void UnInit();

    #if 0
    void OnClientDisconnect(a8::XParams& param);
    void OnTargetServerDisconnect(a8::XParams& param);
    void OnTargetServerConnect(a8::XParams& param);
    #endif
    DownStream* GetGameClientBySocket(int sockhande);
    void BindUpStream(int socket_handle, int conn_instance_id);
    void AddPendingAccount(const std::string& account_id, int socket_handle, long long req_tick);

private:

    void RemovePendingAccount(int socket_handle);

 private:
    a8::Attacher timer_attacher_;
    std::map<int, DownStream*> socket_hash_;
    #if 0
    std::map<int, std::tuple<std::string, long long, timer_list*>> pending_account_hash_;
    #endif
};
