#include "precompile.h"

#include "upstreammgr.h"
#include "upstream.h"
#include "jsondatamgr.h"
#include "app.h"

void UpStreamMgr::Init()
{
}

void UpStreamMgr::UnInit()
{
    for (auto& pair : id_hash_) {
        pair.second->UnInit();
        delete pair.second;
    }
}

UpStream* UpStreamMgr::GetConnByKey(const std::string& key)
{
    auto itr = key_hash_.find(key);
    return itr != key_hash_.end() ? itr->second : nullptr;
}

UpStream* UpStreamMgr::GetConnById(int instance_id)
{
    auto itr = id_hash_.find(instance_id);
    return itr != id_hash_.end() ? itr->second : nullptr;
}

UpStream* UpStreamMgr::RecreateUpStream(const std::string& host, int port)
{
    std::string key = host + ":" + a8::XValue(port).GetString();
    UpStream* conn = GetConnByKey(key);
    if (conn) {
        return conn;
    }
    while (GetConnById(++curr_id_)) {};
    int instance_id = curr_id_;
    std::string remote_ip = host;
    int remote_port = port;

    conn = new UpStream();
    conn->Init(instance_id, remote_ip, remote_port);
    id_hash_[conn->instance_id] = conn;
    key_hash_[key] = conn;
    conn->Open();
    return conn;
}
